Main Page Widgets Namespaces Book

# Gtk::IconTheme Class Reference

Inheritance diagram for Gtk::IconTheme:

[legend]

List of all members.

## Public Member Functions

void | append_search_path (const Glib::ustring& path)
| Appends a directory to the search path.
IconInfo | choose_icon (const Glib::StringArrayHandle& icon_names, int size, IconLookupFlags flags)
| Looks up a named icon and returns a structure containing information such as the filename of the icon.
Glib::ustring | get_example_icon_name () const
| Gets the name of an icon that is representative of the current theme (for instance, to use when presenting a list of themes to the user.
Glib::ArrayHandle<int> | get_icon_sizes (const Glib::ustring& icon_name) const
Glib::ArrayHandle<Glib::ustring> | get_search_path () const
const GtkIconTheme* | gobj () const
| Provides access to the underlying C GObject.
GtkIconTheme* | gobj ()
| Provides access to the underlying C GObject.
GtkIconTheme* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | has_icon (const Glib::ustring& icon_name) const
| Checks whether an icon theme includes an icon for a particular name.
Glib::ListHandle<Glib::ustring> | list_contexts () const
| Gets the list of contexts available within the current hierarchy of icon themes.
Glib::ListHandle<Glib::ustring> | list_icons () const
| Lists the icons in the current icon theme.
Glib::ListHandle<Glib::ustring> | list_icons (const Glib::ustring& context) const
| Lists a subset of icons in the current icon theme, by providing a context string.
Glib::RefPtr<Gdk::Pixbuf> | load_icon (const Glib::ustring& icon_name, int size, IconLookupFlags flags=(IconLookupFlags) 0) const
| Looks up an icon in an icon theme, scales it to the given size and renders it into a pixbuf.
IconInfo | lookup_icon (const Glib::RefPtr<const Gio::Icon>& icon, int size, IconLookupFlags flags) const
IconInfo | lookup_icon (const Glib::ustring& icon_name, int size, IconLookupFlags flags) const
| Looks up a named icon and returns a structure containing information such as the filename of the icon.
void | prepend_search_path (const Glib::ustring& path)
| Prepends a directory to the search path.
bool | rescan_if_needed ()
| Checks to see if the icon theme has changed; if it has, any currently cached information is discarded and will be reloaded next time icon_theme is accessed.
void | set_custom_theme (const Glib::ustring& theme_name)
| Sets the name of the icon theme that the Gtk::IconTheme object uses overriding system configuration.
void | set_screen (const Glib::RefPtr<Gdk::Screen>& screen)
| Sets the screen for an icon theme; the screen is used to track the user's currently configured icon theme, which might be different for different screens.
void | set_search_path (const Glib::ArrayHandle<Glib::ustring>& path)
Glib::SignalProxy0<void> | signal_changed ()
virtual | ~IconTheme ()

## Static Public Member Functions

static void | add_builtin_icon (const Glib::ustring& icon_name, int size, const Glib::RefPtr<Gdk::Pixbuf>& pixbuf)
| Registers a built-in icon for icon theme lookups.
static Glib::RefPtr<IconTheme> | create ()
static Glib::RefPtr<IconTheme> | get_default ()
| Gets the icon theme for the default screen.
static Glib::RefPtr<IconTheme> | get_for_screen (const Glib::RefPtr<Gdk::Screen>& screen)
| Gets the icon theme object associated with screen; if this function has not previously been called for the given screen, a new icon theme object will be created and associated with the screen.

## Protected Member Functions

| IconTheme ()
virtual void | on_changed ()

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr<Gtk::IconTheme> | wrap (GtkIconTheme* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Constructor & Destructor Documentation

virtual Gtk::IconTheme::~IconTheme | ( |  | ) | `[virtual]`

Gtk::IconTheme::IconTheme | ( |  | ) | `[protected]`

## Member Function Documentation

static void Gtk::IconTheme::add_builtin_icon | ( | const Glib::ustring & | icon_name,
|  | int | size,
|  | const Glib::RefPtr<Gdk::Pixbuf>& | pixbuf |
| ) |  |  | `[static]`

Registers a built-in icon for icon theme lookups.

The idea of built-in icons is to allow an application or library that uses themed icons to function requiring files to be present in the file system. For instance, the default images for all of GTK+'s stock icons are registered as built-icons.

In general, if you use add_builtin_icon() you should also install the icon in the icon theme, so that the icon is generally available.

This function will generally be used with pixbufs loaded via gdk_pixbuf_new_from_inline().

Since gtkmm 2.4:

Parameters:

  | icon_name | The name of the icon to register.
  | size | The size at which to register the icon (different images can be registered for the same icon name at different sizes.).
  | pixbuf | Gdk::Pixbuf that contains the image to use for icon_name.

void Gtk::IconTheme::append_search_path | ( | const Glib::ustring & | path | ) |

Appends a directory to the search path.

See set_search_path().

Since gtkmm 2.4:

Parameters:

  | path | Directory name to append to the icon path.

IconInfo Gtk::IconTheme::choose_icon | ( | const Glib::StringArrayHandle & | icon_names,
|  | int | size,
|  | IconLookupFlags | flags |
| ) |  |  |

Looks up a named icon and returns a structure containing information such as the filename of the icon.

The icon can then be rendered into a pixbuf using gtk_icon_info_load_icon(). (load_icon() combines these two steps if all you need is the pixbuf.)

If icon_names contains more than one name, this function tries them all in the given order before falling back to inherited icon themes.

Parameters:

  | icon_names | Array of icon names to lookup.
  | size | Desired icon size.
  | flags | Flags modifying the behavior of the icon lookup.

Returns:
  A Gtk::IconInfo structure containing information about the icon. IconInfo::operator bool() will be false if the icon wasn't found - for instance, if (icon_info) { ... }.

Since gtkmm 2.12:

static Glib::RefPtr<IconTheme> Gtk::IconTheme::create | ( |  | ) | `[static]`

static Glib::RefPtr<IconTheme> Gtk::IconTheme::get_default | ( |  | ) | `[static]`

Gets the icon theme for the default screen.

See get_for_screen().

Returns:
  A unique Gtk::IconTheme associated with the default screen. This icon theme is associated with the screen and can be used as long as the screen is open. Do not ref or unref it.

Since gtkmm 2.4:

Glib::ustring Gtk::IconTheme::get_example_icon_name | ( |  | ) | const

Gets the name of an icon that is representative of the current theme (for instance, to use when presenting a list of themes to the user.

)

Since gtkmm 2.4:

static Glib::RefPtr<IconTheme> Gtk::IconTheme::get_for_screen | ( | const Glib::RefPtr<Gdk::Screen>& | screen | ) | `[static]`

Gets the icon theme object associated with screen; if this function has not previously been called for the given screen, a new icon theme object will be created and associated with the screen.

Icon theme objects are fairly expensive to create, so using this function is usually a better choice than calling than new() and setting the screen yourself; by using this function a single icon theme object will be shared between users.

Parameters:

  | screen | A Gdk::Screen.

Returns:
  A unique Gtk::IconTheme associated with the given screen. This icon theme is associated with the screen and can be used as long as the screen is open. Do not ref or unref it.

Since gtkmm 2.4:

Glib::ArrayHandle<int> Gtk::IconTheme::get_icon_sizes | ( | const Glib::ustring & | icon_name | ) | const

Glib::ArrayHandle<Glib::ustring> Gtk::IconTheme::get_search_path | ( |  | ) | const

const GtkIconTheme* Gtk::IconTheme::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

References Glib::ValueBase::gobject_.

GtkIconTheme* Gtk::IconTheme::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

References Glib::ValueBase::gobject_.

GtkIconTheme* Gtk::IconTheme::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gtk::IconTheme::has_icon | ( | const Glib::ustring & | icon_name | ) | const

Checks whether an icon theme includes an icon for a particular name.

Parameters:

  | icon_name | The name of an icon.

Returns:
  `true` if icon_theme includes an icon for icon_name.

Since gtkmm 2.4:

Glib::ListHandle<Glib::ustring> Gtk::IconTheme::list_contexts | ( |  | ) | const

Gets the list of contexts available within the current hierarchy of icon themes.

Returns:
  A list holding the names of all the contexts in the theme.

Since gtkmm 2.12:

Glib::ListHandle<Glib::ustring> Gtk::IconTheme::list_icons | ( |  | ) | const

Lists the icons in the current icon theme.

Returns:
  A list holding the names of all the icons in the theme.

Since gtkmm 2.10:

Glib::ListHandle<Glib::ustring> Gtk::IconTheme::list_icons | ( | const Glib::ustring & | context | ) | const

Lists a subset of icons in the current icon theme, by providing a context string.

The set of values for the context string is system dependent, but will typically include such values as 'Applications' and 'MimeTypes'.

Parameters:

  | context | A string identifying a particular type of icon.

Returns:
  The names of all the icons in the theme.

Since gtkmm 2.4:

Glib::RefPtr<Gdk::Pixbuf> Gtk::IconTheme::load_icon | ( | const Glib::ustring & | icon_name,
|  | int | size,
|  | IconLookupFlags | flags = `(IconLookupFlags) 0` |
| ) |  |  | const

Looks up an icon in an icon theme, scales it to the given size and renders it into a pixbuf.

This is a convenience function; if more details about the icon are needed, use lookup_icon() followed by gtk_icon_info_load_icon().

Note that you probably want to listen for icon theme changes and update the icon. This is usually done by connecting to the GtkWidget::style-set signal. If for some reason you do not want to update the icon when the icon theme changes, you should consider using gdk_pixbuf_copy() to make a private copy of the pixbuf returned by this function. Otherwise GTK+ may need to keep the old icon theme loaded, which would be a waste of memory.

Parameters:

  | icon_name | The name of the icon to lookup.
  | size | The desired icon size. The resulting icon may not be exactly this size; see gtk_icon_info_load_icon().
  | flags | Flags modifying the behavior of the icon lookup.

Returns:
  The rendered icon; this may be a newly created icon or a new reference to an internal icon, so you must not modify the icon. Use Glib::object_unref() to release your reference to the icon. `0` if the icon isn't found.

Since gtkmm 2.4:

IconInfo Gtk::IconTheme::lookup_icon | ( | const Glib::RefPtr< const Gio::Icon > & | icon,
|  | int | size,
|  | IconLookupFlags | flags |
| ) |  |  | const

IconInfo Gtk::IconTheme::lookup_icon | ( | const Glib::ustring & | icon_name,
|  | int | size,
|  | IconLookupFlags | flags |
| ) |  |  | const

Looks up a named icon and returns a structure containing information such as the filename of the icon.

The icon can then be rendered into a pixbuf using gtk_icon_info_load_icon(). (load_icon() combines these two steps if all you need is the pixbuf.)

Parameters:

  | icon_name | The name of the icon to lookup.
  | size | Desired icon size.
  | flags | Flags modifying the behavior of the icon lookup.

Returns:
  An IconInfo structure containing information about the icon. IconInfo::operator bool() will return false if the icon wasn't found. For instance, if (icon_info) { ... }.

Since gtkmm 2.4:

virtual void Gtk::IconTheme::on_changed | ( |  | ) | `[protected, virtual]`

void Gtk::IconTheme::prepend_search_path | ( | const Glib::ustring & | path | ) |

Prepends a directory to the search path.

See set_search_path().

Since gtkmm 2.4:

Parameters:

  | path | Directory name to prepend to the icon path.

bool Gtk::IconTheme::rescan_if_needed | ( |  | ) |

Checks to see if the icon theme has changed; if it has, any currently cached information is discarded and will be reloaded next time icon_theme is accessed.

Returns:
  `true` if the icon theme has changed and needed to be reloaded.

Since gtkmm 2.4:

void Gtk::IconTheme::set_custom_theme | ( | const Glib::ustring & | theme_name | ) |

Sets the name of the icon theme that the Gtk::IconTheme object uses overriding system configuration.

This function cannot be called on the icon theme objects returned from get_default() and get_for_screen().

Since gtkmm 2.4:

Parameters:

  | theme_name | Name of icon theme to use instead of configured theme, or `0` to unset a previously set custom theme.

void Gtk::IconTheme::set_screen | ( | const Glib::RefPtr<Gdk::Screen>& | screen | ) |

Sets the screen for an icon theme; the screen is used to track the user's currently configured icon theme, which might be different for different screens.

Since gtkmm 2.4:

Parameters:

  | screen | A Gdk::Screen.

void Gtk::IconTheme::set_search_path | ( | const Glib::ArrayHandle< Glib::ustring > & | path | ) |

Glib::SignalProxy0< void > Gtk::IconTheme::signal_changed | ( |  | ) |

Prototype:
  `void on_my_changed()`

## Friends And Related Function Documentation

Glib::RefPtr<Gtk::IconTheme> wrap | ( | GtkIconTheme * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- icontheme.h